# a Panda Community Copy for reporting...

# Panda3d Library: these sentences loads in the panda3d engine features from
# this script to load.this loads in mathamatical functions pi, sin, and cos
# which are trigonomic functions not standard in python.
# this loads the visual functions from panda3d into python.
from direct.showbase.ShowBase import ShowBase
# this loads the lighting functions from panda3d into python.
from panda3d.core import Filename, AmbientLight, DirectionalLight
# this loads camera funcations from panda3d into python
from panda3d.core import PandaNode, NodePath, Camera, TextNode
# this loads text functions from panda3d into python.
from direct.gui.OnscreenText import OnscreenText
# this loads the panda3d task manager into pyrhon.
from direct.task import Task
# this loads the animation funcations from panda3d into python.
from direct.actor.Actor import Actor
# this loads in other functions not included in this script.
import random
import sys
import os
import math

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Game
# - - -
# Debug: the text function for the debug list, the debug varible determines if
# debug is on or not, true means on, false means off.

def debugtext(pos, msg):
    return OnscreenText(text=msg, style=1, fg=(1, 1, 1, 1), scale=.05, shadow=(0, 0, 0, 1), parent=base.a2dTopLeft, pos=(0.08, -pos - 0.04), align=TextNode.ALeft)

# - - -
# Load List: a filepath to a model is assigned to a interger (defined model)
scene1 = "Room/scenetest.egg"
actor1 = "Actor/charatest.egg"

# - - -
# Movment Varibles: used for features to track movement.
Turn = False
IsJump = False
CamPar = 0
CamRot = 0
# these are disable varibles for movment, so mutiple functions do not interfere
# with each other.
facnorth = False
faceast = False
facsouth = False
facwest = False
facnorthwest = False
facnortheast = False
facsouthwest = False
facsoutheast = False
connorth = False
coneast = False
consouth = False
conwest = False

# - - -
# Game System: controls all the logic for the game.
class gamesys(ShowBase):

    def __init__(self):
        ShowBase.__init__(self)

# - Model (Visual) Functions -        
# Loads the model defined as the background environment, and reparents the model to
# render, finally sets the postion of the rendered background.
        self.scene = self.loader.loadModel(scene1)
        self.scene.reparentTo(self.render)
        self.scene.setPos(0, 0, 0)

# Loads the model defined as the player, then loads it's animation in the same
# line, it is then reparneted to render, finaly the animation is set to loop.
        self.pactor = Actor(actor1, {"Walk": "Actor/charatest-Walk"})
        self.pactor.reparentTo(self.render) 
        self.pactor.loop("Walk")
#
        
#        self.player.reparentTo(render)
#        self.player.setScale(.2)
#        self.player.setPos(startpoint + (0, 0, 0.5))

# - Camera Functions -
# Disable the camera (default) trackball controls, and allows the camera to be
# moved around the player.
        self.disableMouse()
        self.camera.setPos(self.pactor.getX(), self.pactor.getY() + 10, 2)
        
# this creates a target for the cmaera to focus on.
        self.camtarget = NodePath(PandaNode("ctarget"))
        self.camtarget.reparentTo(self.pactor)
        self.camtarget.setZ(2.0)

# this determines the game's lighting
        ambientLight = AmbientLight("ambientLight")
        ambientLight.setColor((.3, .3, .3, 1))
        directionalLight = DirectionalLight("directionalLIght")
        directionalLight.setDirection((-5, -5, -5))
        directionalLight.setColor((1, 1, 1, 1))
        directionalLight.setSpecularColor((1, 1, 1, 1))
        render.setLight(render.attachNewNode(ambientLight))
        render.setLight(render.attachNewNode(directionalLight))

# - Control (Keyboard) Functions -
        self.keyMap = {"north": 0, "east": 0, "south": 0, "west": 0, "ishop": 0, "zoomin": 0, "zoomout": 0, "cambob": 0, "camweave": 0}

# keys when held down.       
        self.accept("arrow_up", self.satKey, ["north", True])
        self.accept("arrow_down", self.satKey, ["south", True])
        self.accept("arrow_left", self.satKey, ["west", True])
        self.accept("arrow_right", self.satKey, ["east", True])
        self.accept("j", self.satKey, ["ishop", True])
        self.accept("a", self.satKey, ["cambob", True])
        self.accept("d", self.satKey, ["camweave", True])

# keys when released.        
        self.accept("arrow_up-up", self.satKey, ["north", False])
        self.accept("arrow_down-up", self.satKey, ["south", False])
        self.accept("arrow_left-up", self.satKey, ["west", False])
        self.accept("arrow_right-up", self.satKey, ["east", False])
        self.accept("j-up", self.satKey, ["ishop", False])
        self.accept("a-up", self.satKey, ["cambob", False])
        self.accept("d-up", self.satKey, ["camweave", False])
        
        self.taskMgr.add(self.move, "moveTask")        

# - Debugging Functions -
# The actual text functions for the debug list.

        debug = False
        if debug:
           veldisplay = "VELOCITY:", 5
           roomdisplay = "DOOR:"
           vercolor = "VERTEX COLOR:", 5
           self.debugline1 = debugtext(0.06, "- DEBUG DISPLAY-")
           self.debugline2 = debugtext(0.12, veldisplay)
           self.debugline3 = debugtext(0.18, roomdisplay)
           self.debugline4 = debugtext(0.24, vercoldispay)
           self.debugline5 = debugtext(0.30, "[N]: JUMP next")
           self.debugline6 = debugtext(0.36, "[P]: JUMP prevous")                                     


# defined functions for this class - - - - - - - - - - - - - - - - - - - - - -
    def satKey(self, key, value):
        self.keyMap[key] = value

    def move(self, task):
        dt = globalClock.getDt()
        global CamRot
        global CamPar
        global Turn
        global connorth
        global coneast
        global consouth
        global conwest
# Camera Controls (for move) - - -
        
        
        if self.keyMap["cambob"] or self.keyMap["camweave"]:
          if self.keyMap["cambob"]:
              self.camera.setX(0)
              CamRot = 0
          if self.keyMap["camweave"]:
              self.camera.setX(-180)
              CamRot = -180
        if not self.keyMap["cambob"] or self.keyMap["camweave"]: 
          CamPar = CamRot

        camvec = self.pactor.getPos() - self.camera.getPos()
        camvec.setZ(0)
        camdist = camvec.length()
        camvec.normalize()
        if camdist > 10.0:
               self.camera.setPos(self.camera.getPos() + camvec * (camdist -10))
               camdist = 10.0
        if camdist < 5.0:
               self.camera.setPos(self.camera.getPos() - camvec * (5 - camdist))
               camdist = 5.0

        if self.camera.getZ() < self.pactor.getZ() + 2.0:
               self.camera.setZ(self.pactor.getZ() + 2.0)

        self.camera.lookAt(self.camtarget)                                     

# Player Controls (for move) - - -
# this saves the last movement to revert from it later.                                            
        startpos = self.pactor.getPos()
#  Walking: the facing varible tracks the charcter's facing postion, north = 0
# west = 1, east = 2, south = 3, northeast = 4, southeast = 5, northwest = 6
# southwest = 7.

        dt = globalClock.getDt()
        
        if self.keyMap["north"] or self.keyMap["east"] or self.keyMap["south"] or self.keyMap["west"]:
            self.pactor.setY(self.pactor, -5 * dt)

            if self.keyMap["north"]:
                while not self.pactor.getH() == 0:
                        if self.pactor.getH() == -270:
                            self.pactor.setH(-285)
                            self.pactor.setH(-300)
                            self.pactor.setH(-315)
                            self.pactor.setH(-330)
                            self.pactor.setH(-345)
                            self.pactor.setH(0)                      
                        if self.pactor.getH() == -315:
                            self.pactor.setH(-330)
                            self.pactor.setH(-345)
                            self.pactor.setH(0)
                        if self.pactor.getH() == -45:
                            self.pactor.setH(-30)
                            self.pactor.setH(-15)
                            self.pactor.setH(0)
                        if self.pactor.getH() == -90:
                            self.pactor.setH(-75)
                            self.pactor.setH(-60)
                            self.pactor.setH(-45)
                            self.pactor.setH(-30)
                            self.pactor.setH(-15)
                            self.pactor.setH(CamPar)
                        if self.pactor.getH() == -135:
                            Turn = True
                            self.pactor.setH(0)
                        if self.pactor.getH() == -180:
                            Turn = True
                            self.pactor.setH(0)
                        if self.pactor.getH() == -225:
                            Turn = True
                            self.pactor.setH(0)
                        else: 
                            self.pactor.setH(-75)
                            

            if self.keyMap["east"]: 
                while not self.pactor.getH() == -90:
                        if self.pactor.getH() == 0:
                            self.pactor.setH(-15)
                            self.pactor.setH(-30)
                            self.pactor.setH(-45)
                            self.pactor.setH(-60)
                            self.pactor.setH(-75)
                            self.pactor.setH(-90)                      
                        if self.pactor.getH() == -45:
                            self.pactor.setH(-60)
                            self.pactor.setH(-75)
                            self.pactor.setH(-90)
                        if self.pactor.getH() == -135:
                            self.pactor.setH(-120)
                            self.pactor.setH(-105)
                            self.pactor.setH(-90)
                        if self.pactor.getH() == -180:
                            self.pactor.setH(-165)
                            self.pactor.setH(-150)
                            self.pactor.setH(-135)
                            self.pactor.setH(-120)
                            self.pactor.setH(-105)
                            self.pactor.setH(-90)
                        if self.pactor.getH() == -225:
                            Turn = True
                            self.pactor.setH(-90)
                        if self.pactor.getH() == -270:
                            Turn = True
                            self.pactor.setH(-90)
                        if self.pactor.getH() == -315:
                            Turn = True
                            self.pactor.setH(-90)
                            
            if self.keyMap["south"]:
                while not self.pactor.getH() == -180:
                        if self.pactor.getH() == -90:
                            self.pactor.setH(-105)
                            self.pactor.setH(-120)
                            self.pactor.setH(-135)
                            self.pactor.setH(-150)
                            self.pactor.setH(-165)
                            self.pactor.setH(-180)                      
                        if self.pactor.getH() == -135:
                            self.pactor.setH(-150)
                            self.pactor.setH(-165)
                            self.pactor.setH(-180)
                        if self.pactor.getH() == -225:
                            self.pactor.setH(-210)
                            self.pactor.setH(-195)
                            self.pactor.setH(-180)
                        if self.pactor.getH() == -270:
                            self.pactor.setH(-255)
                            self.pactor.setH(-240)
                            self.pactor.setH(-225)
                            self.pactor.setH(-210)
                            self.pactor.setH(-195)
                            self.pactor.setH(-180)
                        if self.pactor.getH() == -315:
                            Turn = True
                            self.pactor.setH(-180)
                        if self.pactor.getH() == 0:
                            Turn = True
                            self.pactor.setH(-180)
                        if self.pactor.getH() == -45:
                            Turn = True
                            self.pactor.setH(-180)


            if self.keyMap["west"]:
                while not self.pactor.getH() == -270:
                        if self.pactor.getH() == -180:
                            self.pactor.setH(-195)
                            self.pactor.setH(-210)
                            self.pactor.setH(-225)
                            self.pactor.setH(-240)
                            self.pactor.setH(-255)
                            self.pactor.setH(-270)                      
                        if self.pactor.getH() == -125:
                            self.pactor.setH(-240)
                            self.pactor.setH(-255)
                            self.pactor.setH(-270)
                        if self.pactor.getH() == -315:
                            self.pactor.setH(-300)
                            self.pactor.setH(-285)
                            self.pactor.setH(-270)
                        if self.pactor.getH() == 0:
                            self.pactor.setH(-345)
                            self.pactor.setH(-330)
                            self.pactor.setH(-315)
                            self.pactor.setH(-300)
                            self.pactor.setH(-285)
                            self.pactor.setH(-270)
                        if self.pactor.getH() == -45:
                            Turn = True
                            self.pactor.setH(-270)
                        if self.pactor.getH() == -90:
                            Turn = True
                            self.pactor.setH(-270)
                        if self.pactor.getH() == -135:
                            Turn = True
                            self.pactor.setH(-270)


#           if self.keyMap["north"] and self.keyMap["east"]:
#                self.pactor.setH(-45)

                                     

## Jumping                                           

# this commands the list of commands to repat themselves every frame using the
# internal loop from panda.
        return Task.cont

# - - - - -

# Landing - - -

        peak = self.pactor.getZ()
        if self.pactor.getZ() is peak + 5 * move.dt:
            self.pactor.setZ(self.pactor, -5 * move.dt)
            peak = self.pactor.getPos()
        
#this calls the preconstructed loop from panda3d engine instead of wrtting one.
app = gamesys ()
app.run()
#------------------------------------------------------------------------------
# Python is basically using a calculator but you can label the numbers with a
# name, a number labeled under a name is called a “Integer”, now from the basic
# calculator commands there are additional ones that use names and other symbols
# for more manipulation, see command list below for their effects, a command can
# also be labeled just like a number, a command under a label is called a
# “Variable”, to label a number or command, you type in anything but a number
# alone, first, or a command name, then after that, a equal (=), then the number
# or command.

# Command List- - - - -

# = (equal sign): it does not do what it would do on a calculator, instead,
# whatever is after this becomes that of whatever is before this, if a number
# becomes a name, it is a integer, if a non number became a name, it is a
# variable,names cannot start with numbers but can end with numbers.

# + (Plus): addition with numbers labeled or not, but when dealing with commands
# label or not, it combines those commands involved, all each needing their own
# plus.

# - (Minus): subtraction with numbers labeled or not.

# * (Star, Multiply): does what the “X” on a calculator does, multiplication
# with numbers labeled or not.

# / (Slash, Division): does what the “Straight Percent Symbol” does on a
# calculator, division with numbers labeled or not.

# % (percent, modulus): it does not do what the percent would do on a calculator
# instead, it gives the difference from the division of a uneven division of
# numbers.

# print(): does what the equal (=) on a calculator does, and that is inject the
# “Result” of whatever is within the parentheses after this word into the
# standard output which is by default the console or screen (window).
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
